#!/bin/sh
#------------------------------------------------------------------------------
# /tmp/install.sh - installation file for mini_httpd module
#
# Copyright (c) 2004-2010  Marcus Herleb, info(at)herleb(dot)de
# Copyright (c) 2011-2018  The Eisfair Team, team(at)eisfair(dot)org
#
# Creation:     2006-07-01 mh
# Last Update:  $Id: install.sh 52305 2018-03-11 14:47:57Z jed $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version..
#------------------------------------------------------------------------------

# include eislib etc.
. /var/install/include/eislib
. /var/install/include/jedlib

# set variables
module_name='mini_httpd_timesync'

mini_httpd_path=/usr/local/htdocs

myecho --pack ${module_name} --info "running install.sh ..."

# update shared library file
update_jedlib ${module_name}

# make executeable
/usr/local/bin/dtou /usr/local/htdocs/timesync.cgi
chmod +x /usr/local/htdocs/timesync.cgi

myecho --pack ${module_name} "adding menu ..."
/var/install/bin/add-menu --menu "setup.services.mini_httpd.module.menu" \
    "setup.services.mini_httpd.module.${module_name}.menu" "Time-Sync - Show time synchronisation"

# menue entry does not exist - create it
myecho --pack ${module_name} "adding ${module_name} module menu ..."

# delete menu entries (if already exist)
for CGINAME in timesync.cgi ./timesync.cgi timesync.html ./timesync.html
do
    /usr/local/bin/httpd-menu.sh rem "${CGINAME}"
done

# make menu entry (to update old installations)
if [ -f ${mini_httpd_path}/timesync.html ]
then
    /usr/local/bin/httpd-menu.sh add "./timesync.html" "Time-Sync" "Systemtools"
fi

myecho --pack ${module_name} "setting file/directory access rights ..."

chmod -R 550 ${mini_httpd_path}/timesync.cgi

exit 0
