#!/bin/sh
#------------------------------------------------------------------------------
# /usr/local/htdocs/timesync.cgi - show the timesync menu
#
# Copyright (c) 2004-2010  Marcus Herleb, info(at)herleb(dot).de
# Copyright (c) 2011-2018  The Eisfair Team, team(at)eisfair(dot)org
#
# Creation:     2001-02-24 mh
# Last Update:  $Id: timesync.cgi 52305 2018-03-11 14:47:57Z jed $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version..
#------------------------------------------------------------------------------

#exec 2> /tmp/mini-timesync-trace$$.log
#set -x

RTIME=10

myname=`basename $0`
day=`date +%d.%m.%Y`
uhr=`date +%T`
version=v1.0.10

. /etc/config.d/netdate

d_col_tborder='ffffff'
d_col_tdefbg='f0f0f0'
d_col_tdefbg='cfcfcf'

# Parse variables...
eval "`proccgi $*`"

echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!
echo
echo '<html><head>'
echo '<LINK REL=STYLESHEET TYPE="text/css" HREF="main.css">'
echo "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"${RTIME};URL=${myname}\">"
echo "<title><h1>Zeit-Syncronisation mit Internet Zeitserver ${version}</h1></title>"
echo '</head><body bgcolor="#FFFFFF" text="#000000">'

if [ -n "${NETDATE_TIMESERVER}" ]
then
    rm -f /tmp/tserver.devfiles

    ttmp=''
    for tsvr in ${NETDATE_TIMESERVER}
    do
        if [ "${tsvr}" = "tcp" -o "${tsvr}" = "udp" ]
        then
            ttmp="${tsvr}"
        else
            echo ${ttmp} ${tsvr}>> /tmp/tserver.devfiles
            ttmp=''
        fi
    done
fi

echo '<h2>Zeit-Sync - Zeitabgleich &uuml;ber das Netzwerk</h2><br>'
echo "<table border=1 cellpadding=3 cellspacing=0 bgcolor=\"${d_col_tdefbg}\" bordercolor=\"${d_col_tborder}\" width=80%>"

if [ -z "${QUERY_STRING}" ]
then
    echo "  <td align="left" width=40%><b>Datum des Servers: ${day} <b></td>"
    echo "  <td align="left" width=60%><b>Uhrzeit des Servers: ${uhr} Uhr</b></td>"
    echo '  <tr>'

    if [ -f /var/log/log.tserver ]
    then
        timeaccess=`cat /var/log/log.tserver`

        if [ -z "${timeaccess}" ]
        then
            echo '    <td align="left"><font color="#FF00FF"><b>Anfrage wurde nicht beantwortet,</b></td>'
            echo '    <td align="left"><b>bitte sp&auml;ter wiederholen oder anderen Timeserver ausw&auml;hlen!></b></font></td>'
        else
            if [ -f /tmp/tserver ]
            then
                tserver=`cat /tmp/tserver`
            fi

            echo "    <td align=\"left\"><b>Ergebnis der letzten '${tserver}' Zeitserveraktualisierung:</b></td>"
            echo "    <td align=\"left\"><b>${timeaccess}</b></td>"
        fi
    else
        echo '    <td align=\"left\"><font color="#FF00FF"><b>Es wurde noch keine Zeitserveraktualisierung &uuml;ber '
        echo '      den Mini_HTTPD durchgef&uuml;hrt.</b></font></td>'
    fi

    echo '  </tr><tr>'
    echo '    <td align="center"><font color=\"000000\"><b>Zeitserver ausw&auml;hlen &rarr;</b></font></td>'
    echo "    <td align=\"center\" width=200><br><form name=tserverselect method=get action=${myname}>"
    echo '      <select name=tserver>'

    while read tserver
    do
        echo "        <option>${tserver}</option>"
    done < /tmp/tserver.devfiles

    echo '      <input type=submit value="Zeit abfragen"></form></center></td>'
    echo '  </tr>'
else
    tserver=`echo ${QUERY_STRING} | sed -e 's#tserver=##g' -e 's#+# #g'`
    echo "${tserver}" > /tmp/tserver
    /usr/sbin/netdate ${tserver} > /var/log/log.tserver

    echo "  <td><b>Es wurde soeben eine<br>Zeitsynchronisation mit '${tserver}'<br>versucht, bitte warten ...</b></td>"
fi

echo '</table>'
echo '</body></html>'

exit 0
